stages:
  - check
  - build
#   - test
  - deploy
  - destroy


variables:
  DOMAIN: egeneralov.tk
  CHART_NAME: spa


check helm:
  stage: check
  image: registry.gitlab.com/egeneralov/aio-bundle:2.6.0
  script:
    - helm init --client-only
    - helm lint .helm/${CHART_NAME}/
    - helm template .helm/${CHART_NAME}/ | kubeval -
#   only:
#     - merge_requests
#     - branches
#     - tags
#     - pushes


build:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker build -t "${CI_REGISTRY_IMAGE}:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHA" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHA"
    - docker tag "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHA" "$CI_REGISTRY_IMAGE"
    - docker push "$CI_REGISTRY_IMAGE"
#   only:
#     - branches
#     - tags
#     - api
#     - pipelines
#     - pushes
#     - triggers
#     - web
#     - merge_requests


deploy:
  image: registry.gitlab.com/egeneralov/aio-bundle:2.6.0
  stage: deploy

  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.${DOMAIN}
    on_stop: destroy

  script:
    - set -xe
    - export RELEASE_NAME="${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}"

    - export URLS="--set ingress.hosts[0]=${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.${DOMAIN}"

    - export HELM_OPTS="${RELEASE_NAME} .helm/${CHART_NAME}/ --namespace=${KUBE_NAMESPACE} --set image.repository=${CI_REGISTRY_IMAGE} --set image.tag=$CI_COMMIT_REF_SLUG-$CI_COMMIT_SHA ${URLS} --wait --timeout 900"

    - export
    - (helm install --name ${HELM_OPTS} || helm upgrade ${HELM_OPTS} )


destroy:
  image: registry.gitlab.com/egeneralov/aio-bundle:2.6.0
  stage: destroy

  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    action: stop

  variables:
    GIT_STRATEGY: none

  script:
    - helm delete --purge ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}

  when: manual
  except:
    - web


